# Create Hourly Report Preset

POST https://api.letsdeel.com/rest/v2/timesheets/presets
Content-Type: application/json

Create a new hourly report preset.
 **Token scopes**: `timesheets:write`

Reference: https://developer.deel.com/api/endpoints/projects/create-timesheets-preset

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Deel HRIS SCIM API
  version: 1.0.0
paths:
  /timesheets/presets:
    post:
      operationId: create-timesheets-preset
      summary: Create Hourly Report Preset
      description: |-
        Create a new hourly report preset.
         **Token scopes**: `timesheets:write`
      tags:
        - subpackage_projects
      parameters:
        - name: Authorization
          in: header
          description: >
            ## Authentication

            The Deel API uses bearer tokens to authenticate requests. All API
            calls must be made over HTTPS — calls over plain HTTP or without
            authentication will fail.


            ```curl

            curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
              -H 'Authorization: Bearer YOUR-TOKEN-HERE'
            ```


            [Learn more about authentication](/api/authentication)
          required: true
          schema:
            type: string
      responses:
        '201':
          description: Successful operation.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/Projects_createTimesheetsPreset_Response_201
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/CreateHourlyReportPresetRequestBadRequestError
        '401':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/CreateHourlyReportPresetRequestForbiddenError
        '404':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '500':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                data:
                  $ref: >-
                    #/components/schemas/TimesheetsPresetsPostRequestBodyContentApplicationJsonSchemaData
              required:
                - data
servers:
  - url: https://api.letsdeel.com/rest/v2
  - url: https://api-staging.letsdeel.com/rest/v2
components:
  schemas:
    TimesheetsPresetsPostRequestBodyContentApplicationJsonSchemaData:
      type: object
      properties:
        file:
          type:
            - string
            - 'null'
          format: binary
          description: Optional file attachment for the hourly report preset
        rate:
          type: number
          format: double
          description: The hourly rate for this preset (must be greater than 0)
        title:
          type: string
          description: The title of the hourly report preset
        description:
          type:
            - string
            - 'null'
          description: >-
            A detailed description of the hourly report preset's purpose and
            contents
        work_statement_id:
          type: string
          format: uuid
          description: The unique identifier of the associated work statement
        hourly_report_root_preset_id:
          type: string
          format: uuid
          description: The unique identifier of the root preset this report is based on
      required:
        - work_statement_id
        - hourly_report_root_preset_id
      title: TimesheetsPresetsPostRequestBodyContentApplicationJsonSchemaData
    TimesheetsPresetsPostResponsesContentApplicationJsonSchemaData:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: The unique identifier of the newly created hourly report preset
      required:
        - id
      title: TimesheetsPresetsPostResponsesContentApplicationJsonSchemaData
    Projects_createTimesheetsPreset_Response_201:
      type: object
      properties:
        data:
          $ref: >-
            #/components/schemas/TimesheetsPresetsPostResponsesContentApplicationJsonSchemaData
      required:
        - data
      title: Projects_createTimesheetsPreset_Response_201
    CreateHourlyReportPresetRequestBadRequestError:
      type: object
      properties:
        error:
          type: string
      title: CreateHourlyReportPresetRequestBadRequestError
    ApiErrorRequest:
      type: object
      properties:
        method:
          type: string
          description: The HTTP method of the failed request
        url:
          type: string
          description: The relative URL of the failed request
        status:
          type: number
          format: double
          description: The status code of the response
        api_req_id:
          type: string
          description: The request ID of the failed request
        docs:
          type: string
          description: >-
            A link to the official documentation for the requested endpoint
            resource
        source:
          type: string
          description: The source handler which produced the returned error
        code:
          type: number
          format: double
          description: The code of the source handler which produced the returned error
      title: ApiErrorRequest
    ApiError:
      type: object
      properties:
        message:
          type: string
          description: A description of the returned error
        path:
          type: string
          description: The JSON path where input validation failed
      title: ApiError
    ApiErrorContainer:
      type: object
      properties:
        request:
          $ref: '#/components/schemas/ApiErrorRequest'
        errors:
          type: array
          items:
            $ref: '#/components/schemas/ApiError'
      title: ApiErrorContainer
    CreateHourlyReportPresetRequestForbiddenError:
      type: object
      properties:
        error:
          type: string
      title: CreateHourlyReportPresetRequestForbiddenError
  securitySchemes:
    deelToken:
      type: http
      scheme: bearer
      description: >
        ## Authentication

        The Deel API uses bearer tokens to authenticate requests. All API calls
        must be made over HTTPS — calls over plain HTTP or without
        authentication will fail.


        ```curl

        curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
          -H 'Authorization: Bearer YOUR-TOKEN-HERE'
        ```


        [Learn more about authentication](/api/authentication)
    oauth2:
      type: http
      scheme: bearer
      description: >-
        Standard OAuth2 security scheme based on
        https://swagger.io/docs/specification/authentication/

```

## SDK Code Examples

```python
import requests

url = "https://api.letsdeel.com/rest/v2/timesheets/presets"

payload = { "data": {
        "work_statement_id": "123e4567-e89b-12d3-a456-426614174000",
        "hourly_report_root_preset_id": "123e4567-e89b-12d3-a456-426614174000"
    } }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/v2/timesheets/presets';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"data":{"work_statement_id":"123e4567-e89b-12d3-a456-426614174000","hourly_report_root_preset_id":"123e4567-e89b-12d3-a456-426614174000"}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/v2/timesheets/presets"

	payload := strings.NewReader("{\n  \"data\": {\n    \"work_statement_id\": \"123e4567-e89b-12d3-a456-426614174000\",\n    \"hourly_report_root_preset_id\": \"123e4567-e89b-12d3-a456-426614174000\"\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/v2/timesheets/presets")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"data\": {\n    \"work_statement_id\": \"123e4567-e89b-12d3-a456-426614174000\",\n    \"hourly_report_root_preset_id\": \"123e4567-e89b-12d3-a456-426614174000\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.letsdeel.com/rest/v2/timesheets/presets")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"data\": {\n    \"work_statement_id\": \"123e4567-e89b-12d3-a456-426614174000\",\n    \"hourly_report_root_preset_id\": \"123e4567-e89b-12d3-a456-426614174000\"\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.letsdeel.com/rest/v2/timesheets/presets', [
  'body' => '{
  "data": {
    "work_statement_id": "123e4567-e89b-12d3-a456-426614174000",
    "hourly_report_root_preset_id": "123e4567-e89b-12d3-a456-426614174000"
  }
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/v2/timesheets/presets");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"data\": {\n    \"work_statement_id\": \"123e4567-e89b-12d3-a456-426614174000\",\n    \"hourly_report_root_preset_id\": \"123e4567-e89b-12d3-a456-426614174000\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["data": [
    "work_statement_id": "123e4567-e89b-12d3-a456-426614174000",
    "hourly_report_root_preset_id": "123e4567-e89b-12d3-a456-426614174000"
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/v2/timesheets/presets")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```